package com.loafle.overflow.probe.container.crawler.impl.mongodb;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.loafle.overflow.probe.container.crawler.CrawlerTest;
import com.loafle.overflow.probe.container.crawler.config.Config;
import com.loafle.overflow.probe.container.crawler.result.ResultSet;
import org.junit.Ignore;
import org.junit.Test;

import java.io.File;
import java.util.List;
import java.util.Map;

import static org.junit.Assert.*;

public class MongoDBCrawlerTest extends CrawlerTest {

    @Test
    @Ignore
    public void TestCollectMetric() throws Exception {


        // read test resources config/example.json
        ClassLoader classLoader = getClass().getClassLoader();
        String path = classLoader.getResource("config/mongodb/example.json").getFile();

        Config c = objectMapper.readValue(new File(path),Config.class);

        MongoDBCrawler cr = new MongoDBCrawler();
        List<ResultSet> rl = (List<ResultSet>)cr.collectMetric(c);

        for(int indexI = 0 ; indexI < rl.size(); ++indexI) {
            Map<String, String> m = rl.get(indexI).getData();
            for( String key : m.keySet()) {
                System.out.print("key : " + key);
                System.out.print("|| value : ");
                System.out.println(m.get(key));
            }
        }


//        assertEquals(6, m.size());
    }

}