package com.loafle.overflow.probe.container.crawler.impl.jmx.tomcat;

import com.loafle.overflow.probe.container.crawler.config.Config;
import com.loafle.overflow.probe.container.crawler.impl.jmx.JMXCrawler;
import com.loafle.overflow.probe.container.crawler.impl.jmx.JMXCrawlerTest;
import com.loafle.overflow.probe.container.crawler.result.ResultSet;
import org.junit.Ignore;
import org.junit.Test;

import java.io.File;
import java.net.URL;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static org.junit.Assert.assertEquals;

public class TomcatCrawlerTest extends JMXCrawlerTest {

    @Test
    public void testSum() {
        assertEquals(1,1);
    }

    @Ignore
    @Test
    public void TestDoCrawler() throws Exception {

        ClassLoader classLoader = getClass().getClassLoader();
        URL url = classLoader.getResource("config/tomcat/");
        String path = classLoader.getResource("config/tomcat/example1.json").getFile();

        Config c = objectMapper.readValue(new File(path),Config.class);

        JMXCrawler cr = new JMXCrawler();
        List<ResultSet> result = (List<ResultSet>) cr.getInternal(c);

        print("",result);
    }


    //keytool -export -alias alias_name -keystore path_to_keystore_file -rfc -file path_to_certificate_file
    private void print(String s, List<ResultSet> mm) {

        System.out.println(s);

        Map<String,String> m = new HashMap<>();
        for(ResultSet r : mm) {
            m.putAll(r.getData());
        }

        for (Map.Entry<String, String> item : m.entrySet()) {
            System.out.println("key=" + item.getKey() +  " |||||||||||  value=" +  item.getValue());
        }
    }

    @Ignore
    @Test
    public void testParseObject () {

        String s = "org.apache.catalina.mbeans.ConnectorMBean[Catalina:type=Connector,port=8080]";

        int start = s.indexOf("[");
        int end = s.lastIndexOf("]");
        s = s.substring(start + 1,end);
        assertEquals("Catalina:type=Connector,port=8080",s);
    }
}
