package com.loafle.overflow.probe.container.crawler.impl.redis;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.loafle.overflow.probe.container.crawler.CrawlerTest;
import com.loafle.overflow.probe.container.crawler.config.Config;
import com.loafle.overflow.probe.container.crawler.result.ResultSet;
import org.junit.Ignore;
import org.junit.Test;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static org.junit.Assert.*;

public class RedisCralwerTest extends CrawlerTest {

    @Test
    @Ignore
    public void collectMetric() throws Exception {
        ClassLoader classLoader = getClass().getClassLoader();
        String path = classLoader.getResource("config/redis/example.json").getFile();

        Config c = objectMapper.readValue(new File(path),Config.class);

        RedisCralwer rc = new RedisCralwer();
        List<ResultSet> result = (List<ResultSet>) rc.getInternal(c);
        print("",result);
    }


    private void print(String s, List<ResultSet> mm) {

        System.out.println(s);

        Map<String,String> m = new HashMap<>();
        for(ResultSet r : mm) {
            m.putAll(r.getData());
        }

        for (Map.Entry<String, String> item : m.entrySet()) {
            System.out.println("key=" + item.getKey() +  " |||||||||||  value=" +  item.getValue());
        }
    }

}